#pragma once

#include <iostream>
#include <vector>
#include <memory>
#include <optional>
#include <map>

namespace jjx
{
    namespace json {
        enum class token_type { string, number, syntax, boolean, null };
        enum class value_type { string, number, object, array, boolean, null};
        struct token {
            std::string value;
            token_type type;
            int location;
            std::shared_ptr<std::string> full_source;
        };
        struct value {
            std::optional<std::string> string;
            std::optional<double> number;
            std::optional<bool> boolean;
            std::optional<std::vector<value>> array;
            std::optional<std::map<std::string, value>> object;
            value_type type;
        };
        std::tuple<std::vector<json::token>, std::string> lex(std::string);
        std::tuple<json::value, int, std::string> parse(std::vector<json::token>, int index = 0);
        std::tuple<json::value, std::string> parse(std::string);
        std::string deparse(json::value, std::string whitespace = "");
    }

    namespace xml {}
}